. /usr/lib/eole/ihm.sh

len_pf=26

Inactif() {
printf ".  %${len_pf}s => " "$1"
EchoOrange "Désactivé"
}

NoConfig() {
printf ".  %${len_pf}s => " "$1"
EchoOrange "Non configuré"
}

TestIP() {
len=$((len_pf-7))
printf "%-9s %${len}s => " "$2:" "$1"
/usr/bin/fping -t50 -r2 $1 > /dev/null 2>&1
if [ $? -eq 0 ]
then
   EchoVert "Ok"
else
   EchoRouge "Erreur"
fi
}

TestIP2() {
# présentation normale ;)
printf ".  %${len_pf}s => " "$2"
/usr/bin/fping -t50 -r2 $1 > /dev/null 2>&1
if [ $? -eq 0 ]
then
   EchoVert "Ok"
else
   EchoRouge "Erreur"
fi
}

TestARP() {
# recherche de l'interface reseau + test
testip3interface=`ip route get $1 2> /dev/null|sed -ne '/ via /! s/^.* dev \([^ ]\+\) \+src \+.*$/\\1/p;Q'`
[ "$testip3interface" = "" ] && EchoRouge " Erreur interne impossible de determiner l'interface"
ifconfig $testip3interface > /dev/null 2>&1
[ ! $? = 0 ] && EchoRouge " Erreur interne impossible de determiner l'interface"

# utilisation d'arping
printf ".  %${len_pf}s => " "$2"
/usr/bin/arping -w 1 -c 1 -f $1 -I $testip3interface > /dev/null 2>&1
if [ $? -eq 0 ]
then
   EchoVert "Ok"
else
   EchoRouge "Erreur"
fi
}

TestService() {
printf ".  %${len_pf}s => " "$1"
CMD="/usr/bin/tcpcheck 2 $2 2> /dev/null | grep -q \" alive\""
if [ ! "$3" = "" ]; then
    CreoleRun "$CMD" "$3"
    ret=$?
else
    CreoleRun "$CMD"
    ret=$?
fi
if [ $ret -eq 0 ]
then
   EchoVert "Ok"
   return 0
else
   EchoRouge "Erreur"
   return 1
fi
}

TestUDP() {
printf ".  %${len_pf}s => " "$1"
CMD="netstat -unl | grep -q \":$2 \""
if [ ! "$3" = "" ]; then
    CreoleRun "$CMD" "$3"
    ret=$?
else
    CreoleRun "$CMD"
    ret=$?
fi
if [ $ret -eq 0 ]
then
   EchoVert "Ok"
   return 0
else
   EchoRouge "Erreur"
   return 1
fi
}

TestPid() {
printf ".  %${len_pf}s => " "$1"
pidof "$2" > /dev/null
if [ $? -eq 0 ];then
    EchoVert "Ok"
    return 0
else
    EchoRouge "Erreur"
    return 1
fi
}

TestDns() {
printf ".  %${len_pf}s => " "DNS $1"
/usr/bin/host -W2 -tA $2 $1 > /dev/null 2>&1
if [ $? -eq 0 ];then
    EchoVert "Ok"
    return 0
else
    EchoRouge "Erreur"
    return 1
fi
}

TestNTP() {
printf ".  %${len_pf}s => " "$2"
/usr/sbin/ntpdate -q $1 > /dev/null 2>&1
if [ $? -eq 0 ]
then
   EchoVert "Ok"
else
   EchoRouge "Erreur"
fi
}

TestHTTPPage() {
printf ".  %${len_pf}s => " "$1"
/usr/bin/httping -g $2 -c 1 > /dev/null 2>&1
if [ $? -eq 0 ]
then
   EchoVert "Ok"
else
   EchoRouge "Erreur"
fi
}

TestWeb() {
WGET_OPTIONS="-t2 -T3 --delete-after"
WARN_MSG=""
PROXIES_TESTS="PROXY:"
if [ "$(CreoleGet activer_proxy_client)" == "oui" ]
then
    PROXIES_TESTS="PROXY:http://$(CreoleGet proxy_client_adresse):$(CreoleGet proxy_client_port)"
fi

for PROXY_LOOP in $PROXIES_TESTS
do
    PROXY=$(echo $PROXY_LOOP | sed -e 's/^PROXY://')
    export http_proxy=$PROXY
    if [ -n "$PROXY" ]
    then
        Proxy=` echo $http_proxy | sed -e 's!http://!!' `
        TestService "Serveur Proxy" $Proxy
        if [ $? -ne 0 ]
        then
            #EchoRouge "Erreur"
            #return 1
            export http_proxy=
        fi
    fi
    # Test 1er site
    wget -q $WGET_OPTIONS $2
    if [ $? -eq 0 ]
    then
        printf ".  %${len_pf}s => " "$1"
        EchoVert "Ok"
        return 0
    fi
    if [ "$3" != "" ]
    then
        # Test second site
        msg=$(wget -nv $WGET_OPTIONS $3 2>&1)
        ret=$?
        if [ $ret -eq 0 ]
        then
            printf ".  %${len_pf}s => " "$1"
            EchoVert "Ok"
            return 0
        elif [ $ret -eq 8 ]
        then
            WARN_MSG="$msg"
        fi
    fi
done

printf ".  %${len_pf}s => " "$1"
if [ -n "$WARN_MSG" ]
then
    EchoOrange "$WARN_MSG"
else
    EchoRouge "Erreur"
fi
return 1
}

TestCerts() {
    CERTFILE=$1
    CODEERROR=$2
    echo "$CERTFILE" | grep -q '^/etc/ipsec.d/'
    [ $? = 0 ] && CAFILE=/etc/ipsec.d/cacerts/CertifCa.pem || CAFILE=/etc/ssl/certs/ca.crt
    #man verify for CODEERROR
    MESSAGE=$3
    printf ".  %${len_pf}s => " `basename $CERTFILE`
    if [ -e $CAFILE ]; then
        if [ -e $CERTFILE ]; then
            if [ ! -s $CAFILE ] || [ ! -s $CERTFILE ]; then
                EchoRouge "fichier vide"
            else
                sslmsg="`/usr/bin/openssl verify -CAfile $CAFILE -purpose any $CERTFILE`"
                sslerr="`/usr/bin/openssl verify -CAfile $CAFILE -purpose any $CERTFILE 2>&1`"
                if [ ! "$sslmsg" = "$sslerr" ]; then
                    EchoRouge "Erreur openssl"
                else
                    echo $sslmsg |grep -q "^error $CODEERROR at "
                    if [ $? = 0 ]; then
                        EchoRouge "$MESSAGE"
                        return 1
                    else
                        EchoVert "Ok"
                        return 0
                    fi
                fi
            fi
        else
            EchoRouge "$CERTFILE inexistant"
        fi
    else
        EchoRouge "$CAFILE inexistant"
    fi
}

TestConnexion() {
    connexions=( `/bin/netstat -a --$2 -p -n | grep $1 | grep $3` )
    retour=1
    if [ "$2" = "tcp" ]; then
        sens=$4

        if [ "$sens" = "reception" ]; then
            pos=3
            incr=2
            cond='LISTEN'
        elif [ "$sens" = "envoi" ]; then
            pos=4
            incr=1
            cond='ESTABLISHED'
        fi
        for indice in `seq $pos 7 ${#connexions[*]}`; do
            if [[ ${connexions[$indice]} == *$3* ]]; then
                if [[ ${connexions[$(( $indice + $incr ))]} == $cond ]]; then
                    retour=0
                fi
            fi
        done

    elif [ "$2" = "udp" ]; then
        if [ ${#connexions[*]} -gt 1 ]; then
            retour=0
        fi
    fi

    if [[ $retour == 0 ]]; then
        return 0
    else
        return 1
    fi
}

